/*
  binforge - Repository system for Windows
  Copyright (C) 2009 Younes Serraj  Tous droits rservs.

  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la GNU General Public License telle que
  publie par la Free Software Foundation : soit la version 3 de cette
  licence, soit ( votre gr) toute version ultrieure.

  Ce programme est distribu dans lespoir quil vous sera utile, mais SANS
  AUCUNE GARANTIE : sans mme la garantie implicite de COMMERCIALISABILIT
  ni dADQUATION  UN OBJECTIF PARTICULIER. Consultez la Licence Gnrale
  Publique GNU pour plus de dtails.

  Vous devriez avoir reu une copie de la Licence Gnrale Publique GNU avec
  ce programme ; si ce nest pas le cas, consultez :
  <http://www.gnu.org/licenses/>.
*/

#ifdef BINFORGE_H
#ifndef FILES_C
#define FILES_C

int copy_file(char *src, char *dest) {
	FILE *fsrc;
	FILE *fdest;
	char buffer;

	if ((fsrc = fopen(src, "rb")) == NULL)
		return false;
	if ((fdest = fopen(dest, "wb")) == NULL) {
		fclose(fsrc);
		return false;
	}
	
	while ((buffer = getc(fsrc)) != EOF)
		fputc(buffer, fdest);

	fclose(fsrc);
	fclose(fdest);
	
	return true;
}

int file_exists(char *filepath) {
	FILE *fp;

	if ((fp = fopen(filepath, "rb")) == NULL)
		return false;
	
	fclose(fp);
	return true;
}

int eof_reached(FILE *fp) {
	int ret;

	if (feof(fp))
		return true;
	
	if (getc(fp) == EOF) {
		fseek(fp, -1, SEEK_CUR);
		return true;
	}

	return false;
}

int file_size(char *filepath) {
	FILE *fp;
	int size;
	
	fp = fopen(filepath, "rb");
	if (fp == NULL)
		return -1;
	fseek(fp, 0, SEEK_END);
	size = ftell(fp);
	fclose(fp);

	return size;
}

char* extract_filename(char *path) {
	int location;
	int pathlength;
	
	location = findlastchar(path, '\\');
	if (location == -1) {
		location = findlastchar(path, '/');
		if (location == -1)
			return (char*)NULL;
	}
	pathlength = strlen(path);
	if (location == pathlength-1)
		return (char*)NULL;
	
	return (char*)right(path, pathlength-location-1);
}

void remove_files(char *path) {
	struct dirent *d;
    DIR *dir;
    DIR *is_folder = NULL;
    char buffer[256];
	
	if (path[strlen(path)-1] == '\\')
		path[strlen(path)-1] == '\0';
		
    dir = opendir(path);

	while(d = readdir(dir))
	{
		sprintf(buffer, "%s\\%s", path, d->d_name);
		is_folder = opendir(buffer);
		if (is_folder != NULL){
			closedir(is_folder);
			continue;
		}	
		printf("removing \'%s\'... ", d->d_name);
		if (!remove(buffer))
			printf("done.\n");
		else
			printf("failed.\n");
	}
    return;

}

#endif FILES_C
#endif BINFORGE_H
