/*
  binforge - Repository system for Windows
  Copyright (C) 2009 Younes Serraj  Tous droits rservs.

  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la GNU General Public License telle que
  publie par la Free Software Foundation : soit la version 3 de cette
  licence, soit ( votre gr) toute version ultrieure.

  Ce programme est distribu dans lespoir quil vous sera utile, mais SANS
  AUCUNE GARANTIE : sans mme la garantie implicite de COMMERCIALISABILIT
  ni dADQUATION  UN OBJECTIF PARTICULIER. Consultez la Licence Gnrale
  Publique GNU pour plus de dtails.

  Vous devriez avoir reu une copie de la Licence Gnrale Publique GNU avec
  ce programme ; si ce nest pas le cas, consultez :
  <http://www.gnu.org/licenses/>.
*/

#ifdef BINFORGE_H
#ifndef PACKAGES_DATABASE_C
#define PACKAGES_DATABASE_C

/* FILE *fpkgdb */

int pkgdb_open() {
	if ((fpkgdb = fopen(BINFORGE_PACKAGES_DB, "rb+")) == NULL)
		if ((fpkgdb = fopen(BINFORGE_PACKAGES_DB, "wb")) == NULL)
			return false;
	return true;
}

void pkgdb_close() {
	fclose(fpkgdb);
}

int pkgdb_reopen() {
	pkgdb_close();
	pkgdb_open();
}

void pkgdb_clear() {
	pkgdb_close();
	remove(BINFORGE_PACKAGES_DB);
	pkgdb_open();
}

int pkgdb_isopen() {
	if (!ferror(fpkgdb))
		return true;
	else
		return false;
}

int pkgdb_lastid() {
	package tmp;
	
	rewind(fpkgdb);
	if (eof_reached(fpkgdb))
		return 0; // no package written yet. return 0;
	else {
		fseek(fpkgdb, -sizeof(package), SEEK_END);
		fread(&tmp, sizeof(package), 1, fpkgdb);
		return tmp.id; // auto increment
	}
}

int pkgdb_add(package *pkg) {
	
	fseek(fpkgdb, 0, SEEK_END);
	fwrite(pkg, sizeof(package), 1, fpkgdb);
	
	pkgdb_reopen();

	return true;
}

/*int pkgdb_delete(int pkg_id) {
	
}*/

int pkgdb_update(package *pkg) {
	package tmp;
	
	rewind(fpkgdb);
	while (!feof(fpkgdb)) {
		fread(&tmp, sizeof(package), 1, fpkgdb);
		if (tmp.id == pkg->id) {
			pkg->size = tmp.size;
			pkg->released_on = tmp.released_on;
			pkg->updated_on = time(NULL);
			fseek(fpkgdb, -sizeof(package), SEEK_CUR);
			fwrite(pkg, sizeof(package), 1, fpkgdb);
			pkgdb_reopen();
			return true;
		}
	}
	
	return false;
}

int pkgdb_exists(int pkg_id) {
	if (pkgdb_get(pkg_id) == NULL)
		return false;
	return true;
}

package *pkgdb_get(int pkg_id) {
	package *pkg;
	
	pkg = (package*)malloc(sizeof(package));
	rewind(fpkgdb);
	
	while (!feof(fpkgdb)) {
		fread(pkg, sizeof(package), 1, fpkgdb);
		if (feof(fpkgdb))
			break;
		if (pkg->id == pkg_id)
			return (package *)pkg;
	}
	
	free(pkg);
	
	return (package *)NULL;
}

void pkgdb_list() {
	package *pkg;
	
	if (pkgdb_lastid() == 0)
		return;
	
	pkg = (package*)malloc(sizeof(package));
	rewind(fpkgdb);
	
	while (!feof(fpkgdb)) {
		fread(pkg, sizeof(package), 1, fpkgdb);
		if (feof(fpkgdb))
			break;
		pkg_print(pkg);
	}
	
	free(pkg);
}

#endif PACKAGES_DATABASE_C
#endif BINFORGE_H
